<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: ALM_TransParaRepInv.xml */
/* Generado: 2020-08-18 04:21:25 */

/* Mantenimiento de los registros de la tabla ALM_TransParaRepInv */
abstract class BaseALM_TransParaRepInvDP extends ALM_TransParaRepInvBV
{
    /* Constructor ( Establece los valores desde un objeto ALM_TransParaRepInvBN ) */
    public function __construct( ALM_TransParaRepInvBN $o_ALM_TransParaRepInvBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_ALM_TransParaRepInvBN ) )
        {
            $this->setByBN( $o_ALM_TransParaRepInvBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto ALM_TransParaRepInvBN */
    public function setByBN( ALM_TransParaRepInvBN $o_ALM_TransParaRepInvBN )
    {
        if ( !is_null( $o_ALM_TransParaRepInvBN->getIdTrx() ) )
        {
            $this->setIdTrx( $o_ALM_TransParaRepInvBN->getIdTrx() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_ALM_TransParaRepInvBN->getIdCompania() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_ALM_TransParaRepInvBN->getIdSucursal() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getIdNumeroDocumento() ) )
        {
            $this->setIdNumeroDocumento( $o_ALM_TransParaRepInvBN->getIdNumeroDocumento() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getIdTransaccion() ) )
        {
            $this->setIdTransaccion( $o_ALM_TransParaRepInvBN->getIdTransaccion() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getIdAlmacen() ) )
        {
            $this->setIdAlmacen( $o_ALM_TransParaRepInvBN->getIdAlmacen() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getFechaDocumento() ) )
        {
            $this->setFechaDocumento( $o_ALM_TransParaRepInvBN->getFechaDocumento() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getFechaDocumentoOriginal() ) )
        {
            $this->setFechaDocumentoOriginal( $o_ALM_TransParaRepInvBN->getFechaDocumentoOriginal() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getReferenciaTipoDocumento() ) )
        {
            $this->setReferenciaTipoDocumento( $o_ALM_TransParaRepInvBN->getReferenciaTipoDocumento() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getReferenciaNumeroDocumento() ) )
        {
            $this->setReferenciaNumeroDocumento( $o_ALM_TransParaRepInvBN->getReferenciaNumeroDocumento() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getReferenciaTipoDocumentoOriginal() ) )
        {
            $this->setReferenciaTipoDocumentoOriginal( $o_ALM_TransParaRepInvBN->getReferenciaTipoDocumentoOriginal() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getReferenciaNumeroDocumentoOriginal() ) )
        {
            $this->setReferenciaNumeroDocumentoOriginal( $o_ALM_TransParaRepInvBN->getReferenciaNumeroDocumentoOriginal() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getIdItem() ) )
        {
            $this->setIdItem( $o_ALM_TransParaRepInvBN->getIdItem() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getIdLote() ) )
        {
            $this->setIdLote( $o_ALM_TransParaRepInvBN->getIdLote() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getIdSecuencia() ) )
        {
            $this->setIdSecuencia( $o_ALM_TransParaRepInvBN->getIdSecuencia() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getCantOriginal() ) )
        {
            $this->setCantOriginal( $o_ALM_TransParaRepInvBN->getCantOriginal() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getCantEvaluada() ) )
        {
            $this->setCantEvaluada( $o_ALM_TransParaRepInvBN->getCantEvaluada() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getCantSaldo() ) )
        {
            $this->setCantSaldo( $o_ALM_TransParaRepInvBN->getCantSaldo() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getStockFisico() ) )
        {
            $this->setStockFisico( $o_ALM_TransParaRepInvBN->getStockFisico() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getDiasCalculado() ) )
        {
            $this->setDiasCalculado( $o_ALM_TransParaRepInvBN->getDiasCalculado() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_ALM_TransParaRepInvBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_ALM_TransParaRepInvBN->getFechaCreacion() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_ALM_TransParaRepInvBN->getUsuarioModificacion() );
        }
        if ( !is_null( $o_ALM_TransParaRepInvBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_ALM_TransParaRepInvBN->getFechaModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_ALM_TransParaRepInvFN = new ALM_TransParaRepInvFN();
        $o_ALM_TransParaRepInvBN = $o_ALM_TransParaRepInvFN->selectByPk( $this->getIdTrx() );
        if ( is_null( $o_ALM_TransParaRepInvBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO ALM_TransParaRepInv ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdTrx() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTrx";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdTrx()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursal";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdNumeroDocumento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdNumeroDocumento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdNumeroDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTransaccion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTransaccion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdTransaccion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacen() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdAlmacen";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaDocumento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaDocumento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaDocumentoOriginal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaDocumentoOriginal";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaDocumentoOriginal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaTipoDocumento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ReferenciaTipoDocumento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getReferenciaTipoDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaNumeroDocumento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ReferenciaNumeroDocumento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getReferenciaNumeroDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaTipoDocumentoOriginal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ReferenciaTipoDocumentoOriginal";
                $s_SQLQuery2 .= $s_Separator."'".$this->getReferenciaTipoDocumentoOriginal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaNumeroDocumentoOriginal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ReferenciaNumeroDocumentoOriginal";
                $s_SQLQuery2 .= $s_Separator."'".$this->getReferenciaNumeroDocumentoOriginal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdLote() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdLote";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdLote()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSecuencia() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSecuencia";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSecuencia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantOriginal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CantOriginal";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantOriginal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantEvaluada() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CantEvaluada";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantEvaluada()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantSaldo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CantSaldo";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantSaldo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockFisico() ) )
            {
                $s_SQLQuery1 .= $s_Separator."StockFisico";
                $s_SQLQuery2 .= $s_Separator."".$this->getStockFisico()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDiasCalculado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DiasCalculado";
                $s_SQLQuery2 .= $s_Separator."".$this->getDiasCalculado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE ALM_TransParaRepInv SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSucursal = ".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdNumeroDocumento() ) )
            {
                $s_SQLQuery .= $s_Separator."IdNumeroDocumento = '".$this->getIdNumeroDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTransaccion() ) )
            {
                $s_SQLQuery .= $s_Separator."IdTransaccion = '".$this->getIdTransaccion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacen() ) )
            {
                $s_SQLQuery .= $s_Separator."IdAlmacen = '".$this->getIdAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaDocumento() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaDocumento = '".$this->getFechaDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaDocumentoOriginal() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaDocumentoOriginal = '".$this->getFechaDocumentoOriginal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaTipoDocumento() ) )
            {
                $s_SQLQuery .= $s_Separator."ReferenciaTipoDocumento = '".$this->getReferenciaTipoDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaNumeroDocumento() ) )
            {
                $s_SQLQuery .= $s_Separator."ReferenciaNumeroDocumento = '".$this->getReferenciaNumeroDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaTipoDocumentoOriginal() ) )
            {
                $s_SQLQuery .= $s_Separator."ReferenciaTipoDocumentoOriginal = '".$this->getReferenciaTipoDocumentoOriginal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaNumeroDocumentoOriginal() ) )
            {
                $s_SQLQuery .= $s_Separator."ReferenciaNumeroDocumentoOriginal = '".$this->getReferenciaNumeroDocumentoOriginal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery .= $s_Separator."IdItem = '".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdLote() ) )
            {
                $s_SQLQuery .= $s_Separator."IdLote = '".$this->getIdLote()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSecuencia() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSecuencia = ".$this->getIdSecuencia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantOriginal() ) )
            {
                $s_SQLQuery .= $s_Separator."CantOriginal = ".$this->getCantOriginal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantEvaluada() ) )
            {
                $s_SQLQuery .= $s_Separator."CantEvaluada = ".$this->getCantEvaluada()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantSaldo() ) )
            {
                $s_SQLQuery .= $s_Separator."CantSaldo = ".$this->getCantSaldo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockFisico() ) )
            {
                $s_SQLQuery .= $s_Separator."StockFisico = ".$this->getStockFisico()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDiasCalculado() ) )
            {
                $s_SQLQuery .= $s_Separator."DiasCalculado = ".$this->getDiasCalculado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdTrx = ".$this->getIdTrx().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM ALM_TransParaRepInv WHERE  IdTrx = ".$this->getIdTrx().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>